## rustc 1.65.0+dfsg0ubuntu1~llvm2

=== src/llvm-project/clang-tools-extra/include-cleaner/CMakeLists.txt ===
add_subdirectory(lib)
if(CLANG_INCLUDE_TESTS)
  add_subdirectory(test)
  add_subdirectory(unittests)
endif()

=== src/llvm-project/clang-tools-extra/pseudo/CMakeLists.txt ===
include_directories(include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
add_subdirectory(include)
add_subdirectory(gen)
add_subdirectory(lib)
add_subdirectory(tool)
add_subdirectory(fuzzer)
add_subdirectory(benchmarks)
if(CLANG_INCLUDE_TESTS)
  add_subdirectory(unittests)
  add_subdirectory(test)
endif()

=== src/llvm-project/clang/lib/CMakeLists.txt ===
add_subdirectory(Headers)
add_subdirectory(Basic)
add_subdirectory(APINotes)
add_subdirectory(Lex)
add_subdirectory(Parse)
add_subdirectory(AST)
add_subdirectory(ASTMatchers)
add_subdirectory(CrossTU)
add_subdirectory(Sema)
add_subdirectory(CodeGen)
add_subdirectory(Analysis)
add_subdirectory(Edit)
add_subdirectory(ExtractAPI)
add_subdirectory(Rewrite)
if(CLANG_ENABLE_ARCMT)
  add_subdirectory(ARCMigrate)
endif()
add_subdirectory(Driver)
add_subdirectory(Serialization)
add_subdirectory(Frontend)
add_subdirectory(FrontendTool)
add_subdirectory(Tooling)
add_subdirectory(DirectoryWatcher)
add_subdirectory(Index)
add_subdirectory(IndexSerialization)
add_subdirectory(StaticAnalyzer)
add_subdirectory(Format)
if(CLANG_INCLUDE_TESTS)
  add_subdirectory(Testing)
endif()
add_subdirectory(Interpreter)
add_subdirectory(Support)

=== src/llvm-project/clang/tools/CMakeLists.txt ===
create_subdirectory_options(CLANG TOOL)

add_clang_subdirectory(diagtool)
add_clang_subdirectory(driver)
add_clang_subdirectory(apinotes-test)
add_clang_subdirectory(clang-diff)
add_clang_subdirectory(clang-format)
add_clang_subdirectory(clang-format-vs)
add_clang_subdirectory(clang-fuzzer)
add_clang_subdirectory(clang-import-test)
add_clang_subdirectory(clang-nvlink-wrapper)
add_clang_subdirectory(clang-linker-wrapper)
add_clang_subdirectory(clang-offload-packager)
add_clang_subdirectory(clang-offload-bundler)
add_clang_subdirectory(clang-offload-wrapper)
add_clang_subdirectory(clang-scan-deps)
add_clang_subdirectory(clang-repl)

add_clang_subdirectory(c-index-test)

add_clang_subdirectory(clang-rename)
add_clang_subdirectory(clang-refactor)
# For MinGW we only enable shared library if LLVM_LINK_LLVM_DYLIB=ON.
# Without that option resulting library is too close to 2^16 DLL exports limit.
if(UNIX OR (MINGW AND LLVM_LINK_LLVM_DYLIB))
  add_clang_subdirectory(clang-shlib)
endif()

if(CLANG_ENABLE_ARCMT)
  add_clang_subdirectory(arcmt-test)
  add_clang_subdirectory(c-arcmt-test)
endif()

if(CLANG_ENABLE_STATIC_ANALYZER)
  add_clang_subdirectory(clang-check)
  add_clang_subdirectory(clang-extdef-mapping)
  add_clang_subdirectory(scan-build)
  add_clang_subdirectory(scan-build-py)
  add_clang_subdirectory(scan-view)
endif()

# We support checking out the clang-tools-extra repository into the 'extra'
# subdirectory. It contains tools developed as part of the Clang/LLVM project
# on top of the Clang tooling platform. We keep them in a separate repository
# to keep the primary Clang repository small and focused.
# It also may be included by LLVM_EXTERNAL_CLANG_TOOLS_EXTRA_SOURCE_DIR.
add_llvm_external_project(clang-tools-extra extra)

# libclang may require clang-tidy in clang-tools-extra.
add_clang_subdirectory(libclang)

add_clang_subdirectory(amdgpu-arch)

=== src/llvm-project/compiler-rt/include/CMakeLists.txt ===
if (COMPILER_RT_BUILD_SANITIZERS)
  set(SANITIZER_HEADERS
    sanitizer/allocator_interface.h
    sanitizer/asan_interface.h
    sanitizer/common_interface_defs.h
    sanitizer/coverage_interface.h
    sanitizer/dfsan_interface.h
    sanitizer/hwasan_interface.h
    sanitizer/linux_syscall_hooks.h
    sanitizer/lsan_interface.h
    sanitizer/msan_interface.h
    sanitizer/netbsd_syscall_hooks.h
    sanitizer/scudo_interface.h
    sanitizer/tsan_interface.h
    sanitizer/tsan_interface_atomic.h
    sanitizer/ubsan_interface.h
    )
  set(FUZZER_HEADERS
    fuzzer/FuzzedDataProvider.h
    )
endif(COMPILER_RT_BUILD_SANITIZERS)

if (COMPILER_RT_BUILD_MEMPROF)
  set(MEMPROF_HEADERS
    sanitizer/memprof_interface.h
    profile/MemProfData.inc
    )
endif(COMPILER_RT_BUILD_MEMPROF)

if (COMPILER_RT_BUILD_XRAY)
  set(XRAY_HEADERS
    xray/xray_interface.h
    xray/xray_log_interface.h
    xray/xray_records.h
    )
endif(COMPILER_RT_BUILD_XRAY)

if (COMPILER_RT_BUILD_ORC)
  set(ORC_HEADERS
    orc/c_api.h
    )
endif(COMPILER_RT_BUILD_ORC)

if (COMPILER_RT_BUILD_PROFILE)
  set(PROFILE_HEADERS
    profile/InstrProfData.inc
    )
endif(COMPILER_RT_BUILD_PROFILE)

set(COMPILER_RT_HEADERS
  ${SANITIZER_HEADERS}
  ${FUZZER_HEADERS}
  ${MEMPROF_HEADERS}
  ${XRAY_HEADERS}
  ${ORC_HEADERS}
  ${PROFILE_HEADERS})

set(output_dir ${COMPILER_RT_OUTPUT_DIR}/include)

# Copy compiler-rt headers to the build tree.
set(out_files)
foreach( f ${COMPILER_RT_HEADERS} )
  set( src ${CMAKE_CURRENT_SOURCE_DIR}/${f} )
  set( dst ${output_dir}/${f} )
  add_custom_command(OUTPUT ${dst}
    DEPENDS ${src}
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${dst}
    COMMENT "Copying compiler-rt's ${f}...")
  list(APPEND out_files ${dst})
endforeach( f )

add_custom_target(compiler-rt-headers ALL DEPENDS ${out_files})
add_dependencies(compiler-rt compiler-rt-headers)
set_target_properties(compiler-rt-headers PROPERTIES FOLDER "Compiler-RT Misc")

# Install sanitizer headers.
install(FILES ${SANITIZER_HEADERS}
  COMPONENT compiler-rt-headers
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  DESTINATION ${COMPILER_RT_INSTALL_INCLUDE_DIR}/sanitizer)
# Install fuzzer headers.
install(FILES ${FUZZER_HEADERS}
  COMPONENT compiler-rt-headers
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  DESTINATION ${COMPILER_RT_INSTALL_INCLUDE_DIR}/fuzzer)
# Install xray headers.
install(FILES ${XRAY_HEADERS}
  COMPONENT compiler-rt-headers
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  DESTINATION ${COMPILER_RT_INSTALL_INCLUDE_DIR}/xray)
# Install ORC headers.
install(FILES ${ORC_HEADERS}
  COMPONENT compiler-rt-headers
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  DESTINATION ${COMPILER_RT_INSTALL_INCLUDE_DIR}/orc)
# Install profile headers.
install(FILES ${PROFILE_HEADERS}
  COMPONENT compiler-rt-headers
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  DESTINATION ${COMPILER_RT_INSTALL_INCLUDE_DIR}/profile)

if (NOT CMAKE_CONFIGURATION_TYPES) # don't add this for IDEs.
  add_custom_target(install-compiler-rt-headers
                    DEPENDS compiler-rt-headers
                    COMMAND "${CMAKE_COMMAND}"
                            -DCMAKE_INSTALL_COMPONENT="compiler-rt-headers"
                            -P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
                    USES_TERMINAL)
  add_custom_target(install-compiler-rt-headers-stripped
                    DEPENDS compiler-rt-headers
                    COMMAND "${CMAKE_COMMAND}"
                            -DCMAKE_INSTALL_COMPONENT="compiler-rt-headers"
                            -DCMAKE_INSTALL_DO_STRIP=1
                            -P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
                    USES_TERMINAL)
endif()

=== src/llvm-project/libunwind/src/CMakeLists.txt ===
# Get sources

enable_language(C CXX ASM)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(LIBUNWIND_CXX_SOURCES
    libunwind.cpp
    Unwind-EHABI.cpp
    Unwind-seh.cpp
    )
if(APPLE)
  list(APPEND LIBUNWIND_CXX_SOURCES
    Unwind_AppleExtras.cpp
    )
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "AIX")
  list(APPEND LIBUNWIND_CXX_SOURCES
    Unwind_AIXExtras.cpp
    )
endif()

set(LIBUNWIND_C_SOURCES
    UnwindLevel1.c
    UnwindLevel1-gcc-ext.c
    Unwind-sjlj.c
    )

set(LIBUNWIND_ASM_SOURCES
    UnwindRegistersRestore.S
    UnwindRegistersSave.S
    )

# See add_asm_sources() in compiler-rt for explanation of this workaround.
# CMake doesn't work correctly with assembly on AIX. Workaround by compiling
# as C files as well.
if((APPLE AND CMAKE_VERSION VERSION_LESS 3.19) OR
   (MINGW AND CMAKE_VERSION VERSION_LESS 3.17) OR
   (${CMAKE_SYSTEM_NAME} MATCHES "AIX"))
  set_source_files_properties(${LIBUNWIND_ASM_SOURCES} PROPERTIES LANGUAGE C)
endif()

set(LIBUNWIND_HEADERS
    AddressSpace.hpp
    assembly.h
    CompactUnwinder.hpp
    cet_unwind.h
    config.h
    dwarf2.h
    DwarfInstructions.hpp
    DwarfParser.hpp
    EHHeaderParser.hpp
    FrameHeaderCache.hpp
    libunwind_ext.h
    Registers.hpp
    RWMutex.hpp
    Unwind-EHABI.h
    UnwindCursor.hpp
    ../include/libunwind.h
    ../include/unwind.h
    ../include/unwind_itanium.h
    ../include/unwind_arm_ehabi.h
    )
if(APPLE)
  list(APPEND LIBUNWIND_HEADERS
    ../include/mach-o/compact_unwind_encoding.h
    )
endif()

if (MSVC_IDE)
  # Force them all into the headers dir on MSVC, otherwise they end up at
  # project scope because they don't have extensions.
  source_group("Header Files" FILES ${LIBUNWIND_HEADERS})
endif()

if (RUST_SGX)
    # Compile Flags
    add_definitions(-DRUST_SGX)
    add_definitions(-D__NO_STRING_INLINES)
    add_definitions(-D__NO_MATH_INLINES)
    add_definitions(-D_LIBUNWIND_IS_BAREMETAL)
    # Can't use add_definitions because CMake will reorder these arguments
    list(APPEND LIBUNWIND_COMPILE_FLAGS -U_FORTIFY_SOURCE)
    list(APPEND LIBUNWIND_COMPILE_FLAGS -D_FORTIFY_SOURCE=0)

    list(APPEND LIBUNWIND_COMPILE_FLAGS -fno-stack-protector)
    list(APPEND LIBUNWIND_COMPILE_FLAGS -ffreestanding)
    list(APPEND LIBUNWIND_COMPILE_FLAGS -fexceptions)
    # Avoid too new relocation types being emitted, which might prevent linking
    # on older platforms.
    #
    # See https://github.com/rust-lang/rust/issues/34978
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        list(APPEND LIBUNWIND_COMPILE_FLAGS -Wa,-mrelax-relocations=no)
    else()
        list(APPEND LIBUNWIND_COMPILE_FLAGS)
    endif()

    # Sources
    list(APPEND LIBUNWIND_HEADERS   UnwindRustSgx.h)
    list(APPEND LIBUNWIND_C_SOURCES UnwindRustSgx.c)
endif()


set_source_files_properties(${LIBUNWIND_C_SOURCES}
                            PROPERTIES
                              COMPILE_FLAGS "-std=c99")

# See add_asm_sources() in compiler-rt for explanation of this workaround.
if((APPLE AND CMAKE_VERSION VERSION_LESS 3.19) OR (MINGW AND CMAKE_VERSION VERSION_LESS 3.17))
  set_source_files_properties(${LIBUNWIND_ASM_SOURCES} PROPERTIES LANGUAGE C)
endif()

set(LIBUNWIND_SOURCES
    ${LIBUNWIND_CXX_SOURCES}
    ${LIBUNWIND_C_SOURCES}
    ${LIBUNWIND_ASM_SOURCES})

# Generate library list.
add_library_flags_if(LIBUNWIND_HAS_C_LIB c)
if (LIBUNWIND_USE_COMPILER_RT)
  add_library_flags("${LIBUNWIND_BUILTINS_LIBRARY}")
else()
  add_library_flags_if(LIBUNWIND_HAS_GCC_S_LIB gcc_s)
  add_library_flags_if(LIBUNWIND_HAS_GCC_LIB gcc)
endif()
add_library_flags_if(LIBUNWIND_HAS_DL_LIB dl)
if (LIBUNWIND_ENABLE_THREADS AND (NOT RUST_SGX))
  add_library_flags_if(LIBUNWIND_HAS_PTHREAD_LIB pthread)
  add_compile_flags_if(LIBUNWIND_WEAK_PTHREAD_LIB -DLIBUNWIND_USE_WEAK_PTHREAD=1)
endif()

# Setup flags.
add_link_flags_if(CXX_SUPPORTS_UNWINDLIB_EQ_NONE_FLAG --unwindlib=none)
if (CXX_SUPPORTS_NOSTDLIBXX_FLAG)
  add_link_flags_if_supported(-nostdlib++)
else()
  add_link_flags_if_supported(-nodefaultlibs)
endif()

# MINGW_LIBRARIES is defined in config-ix.cmake
add_library_flags_if(MINGW "${MINGW_LIBRARIES}")

if (LIBUNWIND_ENABLE_SHARED AND
    NOT (CXX_SUPPORTS_FNO_EXCEPTIONS_FLAG AND
         CXX_SUPPORTS_FUNWIND_TABLES_FLAG))
  message(FATAL_ERROR
          "Compiler doesn't support generation of unwind tables if exception "
          "support is disabled.  Building libunwind DSO with runtime dependency "
          "on C++ ABI library is not supported.")
endif()

if (APPLE)
  add_compile_flags("-U__STRICT_ANSI__")
  add_link_flags("-compatibility_version 1" "-install_name /usr/lib/libunwind.1.dylib")

  if (CMAKE_OSX_DEPLOYMENT_TARGET STREQUAL "10.6")
    add_link_flags("-current_version ${LIBUNWIND_VERSION}" "/usr/lib/libSystem.B.dylib")
  endif ()
endif ()

string(REPLACE ";" " " LIBUNWIND_COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_CXX_FLAGS "${LIBUNWIND_CXX_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_C_FLAGS "${LIBUNWIND_C_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}")

set_property(SOURCE ${LIBUNWIND_CXX_SOURCES}
             APPEND_STRING PROPERTY COMPILE_FLAGS " ${LIBUNWIND_CXX_FLAGS}")
set_property(SOURCE ${LIBUNWIND_C_SOURCES}
             APPEND_STRING PROPERTY COMPILE_FLAGS " ${LIBUNWIND_C_FLAGS}")

# NOTE: avoid implicit dependencies on C++ runtimes.  libunwind uses C++ for
# ease, but does not rely on C++ at runtime.
set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")

# Build the shared library.
add_library(unwind_shared_objects OBJECT EXCLUDE_FROM_ALL ${LIBUNWIND_SOURCES} ${LIBUNWIND_HEADERS})
if(CMAKE_C_COMPILER_ID STREQUAL MSVC)
  target_compile_options(unwind_shared_objects PRIVATE /GR-)
else()
  target_compile_options(unwind_shared_objects PRIVATE -fno-rtti)
endif()
target_link_libraries(unwind_shared_objects PRIVATE unwind-headers ${LIBUNWIND_LIBRARIES})
set_target_properties(unwind_shared_objects
  PROPERTIES
    CXX_EXTENSIONS OFF
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}"
)
if (CMAKE_POSITION_INDEPENDENT_CODE OR NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
  set_target_properties(unwind_shared_objects PROPERTIES POSITION_INDEPENDENT_CODE ON) # must set manually because it's an object library
endif()

if (LIBUNWIND_ENABLE_SHARED)
  add_library(unwind_shared SHARED)
  target_link_libraries(unwind_shared PUBLIC unwind_shared_objects)
  set_target_properties(unwind_shared
    PROPERTIES
      LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}"
      LINKER_LANGUAGE C
      OUTPUT_NAME "unwind"
      VERSION "1.0"
      SOVERSION "1"
  )

  list(APPEND LIBUNWIND_BUILD_TARGETS "unwind_shared")
  if (LIBUNWIND_INSTALL_SHARED_LIBRARY)
    list(APPEND LIBUNWIND_INSTALL_TARGETS "unwind_shared")
  endif()
endif()

# Build the static library.
add_library(unwind_static_objects OBJECT EXCLUDE_FROM_ALL ${LIBUNWIND_SOURCES} ${LIBUNWIND_HEADERS})
if(CMAKE_C_COMPILER_ID STREQUAL MSVC)
  target_compile_options(unwind_static_objects PRIVATE /GR-)
else()
  target_compile_options(unwind_static_objects PRIVATE -fno-rtti)
endif()
target_link_libraries(unwind_static_objects PRIVATE unwind-headers ${LIBUNWIND_LIBRARIES})
set_target_properties(unwind_static_objects
  PROPERTIES
    CXX_EXTENSIONS OFF
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}"
)

if(LIBUNWIND_HIDE_SYMBOLS)
  target_add_compile_flags_if_supported(unwind_static_objects PRIVATE -fvisibility=hidden)
  target_add_compile_flags_if_supported(unwind_static_objects PRIVATE -fvisibility-global-new-delete-hidden)
  target_compile_definitions(unwind_static_objects PRIVATE _LIBUNWIND_HIDE_SYMBOLS)
endif()

if (LIBUNWIND_ENABLE_STATIC)
  add_library(unwind_static STATIC)
  target_link_libraries(unwind_static PUBLIC unwind_static_objects)
  set_target_properties(unwind_static
    PROPERTIES
      LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}"
      LINKER_LANGUAGE C
      OUTPUT_NAME "unwind"
  )

  list(APPEND LIBUNWIND_BUILD_TARGETS "unwind_static")
  if (LIBUNWIND_INSTALL_STATIC_LIBRARY)
    list(APPEND LIBUNWIND_INSTALL_TARGETS "unwind_static")
  endif()
endif()

# Add a meta-target for both libraries.
add_custom_target(unwind DEPENDS ${LIBUNWIND_BUILD_TARGETS})

if (LIBUNWIND_INSTALL_LIBRARY)
  install(TARGETS ${LIBUNWIND_INSTALL_TARGETS}
    LIBRARY DESTINATION ${LIBUNWIND_INSTALL_LIBRARY_DIR} COMPONENT unwind
    ARCHIVE DESTINATION ${LIBUNWIND_INSTALL_LIBRARY_DIR} COMPONENT unwind
    RUNTIME DESTINATION ${LIBUNWIND_INSTALL_RUNTIME_DIR} COMPONENT unwind)
endif()

if (NOT CMAKE_CONFIGURATION_TYPES AND LIBUNWIND_INSTALL_LIBRARY)
  add_custom_target(install-unwind
    DEPENDS unwind
    COMMAND "${CMAKE_COMMAND}"
            -DCMAKE_INSTALL_COMPONENT=unwind
            -P "${LIBUNWIND_BINARY_DIR}/cmake_install.cmake")
  add_custom_target(install-unwind-stripped
    DEPENDS unwind
    COMMAND "${CMAKE_COMMAND}"
            -DCMAKE_INSTALL_COMPONENT=unwind
            -DCMAKE_INSTALL_DO_STRIP=1
            -P "${LIBUNWIND_BINARY_DIR}/cmake_install.cmake")
  if(LIBUNWIND_INSTALL_HEADERS)
    add_dependencies(install-unwind install-unwind-headers)
    add_dependencies(install-unwind-stripped install-unwind-headers-stripped)
  endif()
endif()

=== src/llvm-project/llvm/test/CMakeLists.txt ===
llvm_canonicalize_cmake_booleans(
  BUILD_SHARED_LIBS
  LLVM_HAVE_LIBXAR
  HAVE_OCAMLOPT
  LLVM_ENABLE_DIA_SDK
  LLVM_ENABLE_FFI
  LLVM_ENABLE_THREADS
  LLVM_ENABLE_CURL
  LLVM_ENABLE_HTTPLIB
  LLVM_ENABLE_ZLIB
  LLVM_ENABLE_LIBXML2
  LLVM_INCLUDE_GO_TESTS
  LLVM_LINK_LLVM_DYLIB
  LLVM_TOOL_LTO_BUILD
  LLVM_USE_INTEL_JITEVENTS
  LLVM_BUILD_EXAMPLES
  LLVM_ENABLE_PLUGINS
  LLVM_BYE_LINK_INTO_TOOLS
  LLVM_HAVE_TF_AOT
  LLVM_HAVE_TF_API
  LLVM_INLINER_MODEL_AUTOGENERATED
  LLVM_RAEVICT_MODEL_AUTOGENERATED
  LLVM_ENABLE_EXPENSIVE_CHECKS
  LLVM_INCLUDE_DXIL_TESTS
  LLVM_TOOL_LLVM_DRIVER_BUILD
  )

configure_lit_site_cfg(
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg.py
  MAIN_CONFIG
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py
  PATHS
  "CMAKE_OSX_SYSROOT"
  "LLVM_SOURCE_DIR"
  "LLVM_BINARY_DIR"
  "LLVM_TOOLS_DIR"
  "LLVM_LIBS_DIR"
  "SHLIBDIR"
  )
configure_lit_site_cfg(
  ${CMAKE_CURRENT_SOURCE_DIR}/Unit/lit.site.cfg.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/Unit/lit.site.cfg.py
  MAIN_CONFIG
  ${CMAKE_CURRENT_SOURCE_DIR}/Unit/lit.cfg.py
  PATHS
  "LLVM_SOURCE_DIR"
  "LLVM_BINARY_DIR"
  "LLVM_TOOLS_DIR"
  "SHLIBDIR"
  )

# Set the depends list as a variable so that it can grow conditionally.
# NOTE: Sync the substitutions in test/lit.cfg when adding to this list.
set(LLVM_TEST_DEPENDS
          BugpointPasses
          FileCheck
          LLVMHello
          LLVMWindowsDriver
          UnitTests
          bugpoint
          count
          llc
          lli
          lli-child-target
          llvm-addr2line
          llvm-ar
          llvm-as
          llvm-bcanalyzer
          llvm-bitcode-strip
          llvm-c-test
          llvm-cat
          llvm-cfi-verify
          llvm-config
          llvm-cov
          llvm-cvtres
          llvm-cxxdump
          llvm-cxxfilt
          llvm-cxxmap
          llvm-debuginfod-find
          llvm-diff
          llvm-dis
          llvm-dlltool
          dsymutil
          llvm-dwarfdump
          llvm-dwarfutil
          llvm-dwp
          llvm-exegesis
          llvm-extract
          llvm-gsymutil
          llvm-isel-fuzzer
          llvm-ifs
          llvm-install-name-tool
          llvm-jitlink
          llvm-lib
          llvm-libtool-darwin
          llvm-link
          llvm-lipo
          llvm-locstats
          llvm-lto2
          llvm-mc
          llvm-mca
          llvm-ml
          llvm-modextract
          llvm-mt
          llvm-nm
          llvm-objcopy
          llvm-objdump
          llvm-opt-fuzzer
          llvm-opt-report
          llvm-otool
          llvm-pdbutil
          llvm-profdata
          llvm-profgen
          llvm-ranlib
          llvm-rc
          llvm-readobj
          llvm-readelf
          llvm-reduce
          llvm-remark-size-diff
          llvm-rtdyld
          llvm-sim
          llvm-size
          llvm-split
          llvm-stress
          llvm-strings
          llvm-strip
          llvm-symbolizer
          llvm-tblgen
          llvm-tapi-diff
          llvm-tli-checker
          llvm-undname
          llvm-windres
          llvm-xray
          not
          obj2yaml
          opt
          sancov
          sanstats
          split-file
          verify-uselistorder
          yaml-bench
          yaml2obj
        )

if(TARGET llvm-lto)
  set(LLVM_TEST_DEPENDS ${LLVM_TEST_DEPENDS} llvm-lto)
endif()

if(TARGET llvm-driver)
  set(LLVM_TEST_DEPENDS ${LLVM_TEST_DEPENDS} llvm-driver)
endif()

# If Intel JIT events are supported, depend on a tool that tests the listener.
if( LLVM_USE_INTEL_JITEVENTS )
  set(LLVM_TEST_DEPENDS ${LLVM_TEST_DEPENDS} llvm-jitlistener)
endif( LLVM_USE_INTEL_JITEVENTS )

if(TARGET LLVMgold)
  set(LLVM_TEST_DEPENDS ${LLVM_TEST_DEPENDS} LLVMgold)
endif()

if(TARGET llvm-go)
  set(LLVM_TEST_DEPENDS ${LLVM_TEST_DEPENDS} llvm-go)
endif()

if(TARGET LTO)
  set(LLVM_TEST_DEPENDS ${LLVM_TEST_DEPENDS} LTO)
endif()

if(LLVM_BUILD_EXAMPLES)
  list(APPEND LLVM_TEST_DEPENDS
    Kaleidoscope-Ch3
    Kaleidoscope-Ch4
    Kaleidoscope-Ch5
    Kaleidoscope-Ch6
    Kaleidoscope-Ch7
    LLJITWithThinLTOSummaries
    OrcV2CBindingsBasicUsage
    OrcV2CBindingsAddObjectFile
    OrcV2CBindingsRemovableCode
    OrcV2CBindingsReflectProcessSymbols
    OrcV2CBindingsLazy
    OrcV2CBindingsVeryLazy
    )
  if(CMAKE_HOST_UNIX)
    list(APPEND LLVM_TEST_DEPENDS
      LLJITWithRemoteDebugging
      )
  endif()
  if (NOT WIN32)
    list(APPEND LLVM_TEST_DEPENDS
      Bye
      )
  endif()
endif()

if(TARGET ocaml_llvm)
  # Clear all non-OCaml cross-target dependencies when building out-of-tree.
  if(LLVM_OCAML_OUT_OF_TREE)
    set(LLVM_TEST_DEPENDS)
  endif()

  set(LLVM_TEST_DEPENDS ${LLVM_TEST_DEPENDS}
          ocaml_llvm
          ocaml_llvm_all_backends
          ocaml_llvm_analysis
          ocaml_llvm_bitreader
          ocaml_llvm_bitwriter
          ocaml_llvm_executionengine
          ocaml_llvm_irreader
          ocaml_llvm_linker
          ocaml_llvm_target
          ocaml_llvm_ipo
          ocaml_llvm_passmgr_builder
          ocaml_llvm_scalar_opts
          ocaml_llvm_transform_utils
          ocaml_llvm_vectorize
        )
endif()

if (LLVM_INCLUDE_DXIL_TESTS)
  list(APPEND LLVM_TEST_DEPENDS dxil-dis)
endif()

add_custom_target(llvm-test-depends DEPENDS ${LLVM_TEST_DEPENDS})
set_target_properties(llvm-test-depends PROPERTIES FOLDER "Tests")

if(LLVM_BUILD_TOOLS)
  set(exclude_from_check_all "")
else()
  set(exclude_from_check_all "EXCLUDE_FROM_CHECK_ALL")
endif()

add_lit_testsuite(check-llvm "Running the LLVM regression tests"
  ${CMAKE_CURRENT_BINARY_DIR}
  ${exclude_from_check_all}
  DEPENDS ${LLVM_TEST_DEPENDS}
  )
set_target_properties(check-llvm PROPERTIES FOLDER "Tests")

add_lit_testsuites(LLVM ${CMAKE_CURRENT_SOURCE_DIR}
  ${exclude_from_check_all}
  DEPENDS ${LLVM_TEST_DEPENDS}
  FOLDER "Tests/Subdirectories"
  )

# Setup an alias for 'check-all'.
add_custom_target(check)
add_dependencies(check check-all)
set_target_properties(check PROPERTIES FOLDER "Tests")

=== src/test/run-make-fulldeps/a-b-a-linker-guard/Makefile ===
include ../tools.mk

# Test that if we build `b` against a version of `a` that has one set
# of types, it will not run with a dylib that has a different set of
# types.

# NOTE(eddyb) this test only works with the `legacy` mangling,
# and will probably get removed once `legacy` is gone.

all:
	$(RUSTC) a.rs --cfg x -C prefer-dynamic -Z unstable-options -C symbol-mangling-version=legacy
	$(RUSTC) b.rs -C prefer-dynamic -Z unstable-options -C symbol-mangling-version=legacy
	$(call RUN,b)
	$(RUSTC) a.rs --cfg y -C prefer-dynamic -Z unstable-options -C symbol-mangling-version=legacy
	$(call FAIL,b)

=== src/test/run-make-fulldeps/alloc-no-oom-handling/Makefile ===
include ../tools.mk

all:
	$(RUSTC) --edition=2021 -Dwarnings --crate-type=rlib ../../../../library/alloc/src/lib.rs --cfg no_global_oom_handling

=== src/test/run-make-fulldeps/arguments-non-c-like-enum/Makefile ===
include ../tools.mk

all:
	$(RUSTC) --crate-type=staticlib nonclike.rs
	$(CC) test.c $(call STATICLIB,nonclike) $(call OUT_EXE,test) \
		$(EXTRACFLAGS) $(EXTRACXXFLAGS)
	$(call RUN,test)

=== src/test/run-make-fulldeps/c-dynamic-dylib/Makefile ===
include ../tools.mk

# ignore-macos
#
# This hits an assertion in the linker on older versions of osx apparently

all: $(call DYLIB,cfoo)
	$(RUSTC) foo.rs -C prefer-dynamic
	$(RUSTC) bar.rs
	$(call RUN,bar)
	$(call REMOVE_DYLIBS,cfoo)
	$(call FAIL,bar)

=== src/test/run-make-fulldeps/c-dynamic-rlib/Makefile ===
include ../tools.mk

# ignore-macos
#
# This hits an assertion in the linker on older versions of osx apparently

# This overrides the LD_LIBRARY_PATH for RUN
TARGET_RPATH_DIR:=$(TARGET_RPATH_DIR):$(TMPDIR)

all: $(call DYLIB,cfoo)
	$(RUSTC) foo.rs
	$(RUSTC) bar.rs
	$(call RUN,bar)
	$(call REMOVE_DYLIBS,cfoo)
	$(call FAIL,bar)

=== debian/changelog ===
rustc (1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.18.04) bionic; urgency=medium

  * Update the vendored LLVM 15 to the latest bugfix release to fix ppc64el
    build.
  * Cherry-pick upstream patch to fix FTBFS on ppc64el and arm64

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 25 Jan 2023 18:02:05 +0100

rustc (1.65.0+dfsg0ubuntu1~llvm-0ubuntu0.18.04) bionic; urgency=medium

  * Backport to bionic (LP: #2000839)
  * Comment out vendored source tracking
  * Re-enable embedded LLVM:
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
    - Adjust debian/watch to include +llvm in upstream version.
    - Remove the rust-all dependency on llvm-14 due to vendoring
  * Revert debhelper compat 13 bump back to 11
  * d/control: Build-depend on cmake-mozilla

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 20 Jan 2023 18:30:55 +0100

rustc (1.65.0+dfsg0ubuntu1-0ubuntu2) lunar; urgency=medium

  * d/control: actually bump the version number in the package names

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 20 Jan 2023 16:18:38 +0100

rustc (1.65.0+dfsg0ubuntu1-0ubuntu1) lunar; urgency=medium

  [ Simon Chopin ]
  * New upstream release (LP: #2000839)
  * d/p/u-arm-compiler-builtins-add-sync-builtin-fallbacks.patch:
    Dropped, applied upstream
  * Update vendored deps field

  [ Fabian Grünbichler ]
  * add overrides for rust-analyzer test data
  * update d/copyright
  * cherry-pick fix for compiletest with rpath=false
  * Update Files-Excluded for new upstream version 1.65.0
  * Update early-stage patches for 1.65.0+dfsg1


 -- Simon Chopin <schopin@ubuntu.com>  Fri, 20 Jan 2023 10:43:28 +0100

=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 11),
# dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo:native (>= 0.60.0)      <!pkg.rustc.dlstage0>,
 rustc:native (>= 1.64.0+dfsg) <!pkg.rustc.dlstage0>,
 rustc:native (<= 1.65.0++)    <!pkg.rustc.dlstage0>,
 cmake-mozilla,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# Required for llvm build
 autotools-dev,
 m4,
 ninja-build,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
 fonts-nanum <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust
XS-Vendored-Sources-Rust: addr2line@0.16.0, addr2line@0.17.0, adler@0.2.3, adler@1.0.2, ahash@0.7.6, aho-corasick@0.7.18, always-assert@0.1.2, ammonia@3.2.0, annotate-snippets@0.9.1, ansi_term@0.12.1, anyhow@1.0.65, array_tool@1.0.3, arrayvec@0.7.2, askama@0.11.0, askama_derive@0.11.0, askama_escape@0.10.2, askama_shared@0.12.0, atty@0.2.14, autocfg@1.1.0, backtrace@0.3.66, bitflags@1.3.2, block-buffer@0.10.2, bstr@0.2.17, bytecount@0.6.2, bytes@1.0.1, camino@1.1.1, cargo-platform@0.1.2, cargo_metadata@0.14.0, cargo_metadata@0.15.0, cc@1.0.73, cfg-if@0.1.10, cfg-if@1.0.0, chalk-derive@0.80.0, chalk-engine@0.80.0, chalk-ir@0.80.0, chalk-solve@0.80.0, chrono@0.4.19, clap@3.2.20, clap_complete@3.1.1, clap_derive@3.2.18, clap_lex@0.2.2, cmake@0.1.48, colored@2.0.0, compiler_builtins@0.1.79, compiletest_rs@0.8.0, core-foundation-sys@0.8.3, countme@3.0.1, cov-mark@2.0.0-pre.1, cpufeatures@0.2.2, crc32fast@1.3.2, crossbeam-channel@0.5.6, crossbeam-deque@0.8.2, crossbeam-epoch@0.9.10, crossbeam-utils@0.8.11, crypto-common@0.1.3, cstr@0.2.8, ctor@0.1.22, dashmap@5.3.4, datafrog@2.0.1, derive-new@0.5.8, diff@0.1.13, digest@0.10.3, dirs-next@2.0.0, dirs-sys-next@0.1.2, dirs-sys@0.3.6, dirs@4.0.0, dissimilar@1.0.4, dlmalloc@0.2.3, drop_bomb@0.1.5, either@1.8.0, elasticlunr-rs@3.0.0, ena@0.14.0, env_logger@0.7.1, env_logger@0.9.0, errno-dragonfly@0.1.2, errno@0.2.8, expect-test@1.4.0, fallible-iterator@0.2.0, fd-lock@3.0.6, filetime@0.2.17, fixedbitset@0.2.0, flate2@1.0.24, fluent-bundle@0.15.2, fluent-langneg@0.13.0, fluent-syntax@0.11.0, fnv@1.0.7, form_urlencoded@1.0.1, fortanix-sgx-abi@0.5.0, fs-err@2.8.1, futf@0.1.5, futures-channel@0.3.19, futures-core@0.3.19, futures-executor@0.3.19, futures-io@0.3.19, futures-macro@0.3.19, futures-sink@0.3.19, futures-task@0.3.19, futures-util@0.3.19, futures@0.3.19, generic-array@0.14.5, getopts@0.2.21, getrandom@0.1.14, getrandom@0.2.7, gimli@0.25.0, gimli@0.26.2, glob@0.3.0, globset@0.4.9, gsgdt@0.1.2, handlebars@4.3.3, hashbrown@0.12.3, heck@0.4.0, hermit-abi@0.1.19, hermit-abi@0.2.6, hex@0.4.3, home@0.5.3, html5ever@0.26.0, humantime@1.3.0, humantime@2.0.1, idna@0.2.3, if_chain@1.0.0, ignore@0.4.18, indexmap@1.9.1, indoc@1.0.6, instant@0.1.12, intl-memoizer@0.5.1, intl_pluralrules@7.0.1, io-lifetimes@0.7.2, itertools@0.10.3, itoa@1.0.3, jobserver@0.1.24, jsonpath_lib@0.2.6, lazy_static@1.4.0, lazycell@1.3.0, libc@0.2.132, libloading@0.7.3, libm@0.1.4, linux-raw-sys@0.0.46, lock_api@0.4.7, log@0.4.17, lsp-types@0.93.1, lzma-sys@0.1.17, mac@0.1.1, maplit@1.0.2, markup5ever@0.11.0, matchers@0.1.0, matches@0.1.9, md-5@0.10.0, mdbook@0.4.21, measureme@10.1.0, memchr@2.5.0, memmap2@0.2.1, memmap2@0.5.7, memoffset@0.6.5, minifier@0.2.2, minimal-lexical@0.2.1, miniz_oxide@0.4.0, miniz_oxide@0.5.3, miow@0.3.7, miow@0.4.0, new_debug_unreachable@1.0.4, nom@7.1.0, ntapi@0.3.7, num-integer@0.1.43, num-traits@0.2.12, num_cpus@1.13.1, object@0.26.2, object@0.29.0, odht@0.3.1, once_cell@1.13.1, opener@0.5.0, os_str_bytes@6.0.0, output_vt100@0.1.3, packed_simd_2@0.3.4, parking_lot@0.11.2, parking_lot@0.12.1, parking_lot_core@0.8.5, parking_lot_core@0.9.3, pathdiff@0.2.1, percent-encoding@2.1.0, perf-event-open-sys@1.0.1, perf-event@0.4.7, pest@2.3.0, pest_derive@2.3.0, pest_generator@2.3.0, pest_meta@2.3.0, petgraph@0.5.1, phf@0.10.1, phf_codegen@0.10.0, phf_generator@0.10.0, phf_shared@0.10.0, pin-project-lite@0.2.9, pin-utils@0.1.0, pkg-config@0.3.25, polonius-engine@0.13.0, ppv-lite86@0.2.8, precomputed-hash@0.1.1, pretty_assertions@0.7.2, proc-macro-error-attr@1.0.4, proc-macro-error@1.0.4, proc-macro-hack@0.5.19, proc-macro2@1.0.43, psm@0.1.16, pulldown-cmark@0.9.2, punycode@0.4.1, quick-error@1.2.3, quine-mc_cluskey@0.2.4, quote@1.0.21, rand@0.7.3, rand@0.8.5, rand_chacha@0.2.2, rand_chacha@0.3.0, rand_core@0.5.1, rand_core@0.6.2, rand_hc@0.2.0, rand_xorshift@0.2.0, rand_xoshiro@0.6.0, rayon-core@1.9.3, rayon@1.5.3, redox_syscall@0.2.16, redox_users@0.4.0, regex-automata@0.1.10, regex-syntax@0.6.27, regex@1.6.0, remove_dir_all@0.5.3, rls-data@0.19.1, rls-span@0.5.3, rowan@0.15.8, rustc-ap-rustc_lexer@725.0.0, rustc-demangle@0.1.21, rustc-hash@1.1.0, rustc-rayon-core@0.4.1, rustc-rayon@0.4.0, rustc-semver@1.1.0, rustfix@0.6.1, rustix@0.35.6, rustversion@1.0.5, ryu@1.0.11, same-file@1.0.6, scoped-tls@1.0.0, scopeguard@1.1.0, self_cell@0.10.2, semver@1.0.13, serde@1.0.143, serde_derive@1.0.143, serde_json@1.0.85, serde_repr@0.1.9, sha-1@0.10.0, sha2@0.10.2, sharded-slab@0.1.4, shell-escape@0.1.5, shlex@1.0.0, siphasher@0.3.3, slab@0.4.2, smallvec@1.9.0, smol_str@0.1.23, snap@1.0.5, stable_deref_trait@1.2.0, stacker@0.1.14, string_cache@0.8.3, string_cache_codegen@0.5.2, strsim@0.10.0, syn@1.0.99, synstructure@0.12.6, sysinfo@0.24.2, tar@0.4.38, tempfile@3.2.0, tendril@0.4.3, term@0.7.0, termcolor@1.1.2, termize@0.1.1, tester@0.9.0, text-size@1.1.0, textwrap@0.15.0, thin-vec@0.2.8, thiserror-impl@1.0.33, thiserror@1.0.33, thorin-dwp@0.3.0, thread_local@1.1.4, time@0.1.43, tinystr@0.3.4, tinyvec@1.6.0, tinyvec_macros@0.1.0, tokio@1.8.4, toml@0.5.9, topological-sort@0.1.0, tracing-attributes@0.1.22, tracing-core@0.1.29, tracing-log@0.1.3, tracing-subscriber@0.3.15, tracing-tree@0.2.1, tracing@0.1.36, type-map@0.4.0, typenum@1.15.0, ucd-parse@0.1.8, ucd-trie@0.1.3, ungrammar@1.16.1, unic-char-property@0.9.0, unic-char-range@0.9.0, unic-common@0.9.0, unic-emoji-char@0.9.0, unic-langid-impl@0.9.0, unic-langid-macros-impl@0.9.0, unic-langid-macros@0.9.0, unic-langid@0.9.0, unic-ucd-version@0.9.0, unicase@2.6.0, unicode-bidi@0.3.8, unicode-ident@1.0.1, unicode-normalization@0.1.21, unicode-script@0.5.3, unicode-security@0.0.5, unicode-segmentation@1.9.0, unicode-width@0.1.9, unicode-xid@0.2.3, unicode_categories@0.1.1, unified-diff@0.2.1, url@2.2.2, utf-8@0.7.5, valuable@0.1.0, version_check@0.9.4, walkdir@2.3.2, wasi@0.11.0+wasi-snapshot-preview1, wasi@0.9.0+wasi-snapshot-preview1, winapi-i686-pc-windows-gnu@0.4.0, winapi-util@0.1.5, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9, windows-sys@0.28.0, windows-sys@0.36.1, windows_aarch64_msvc@0.28.0, windows_aarch64_msvc@0.36.1, windows_i686_gnu@0.28.0, windows_i686_gnu@0.36.1, windows_i686_msvc@0.28.0, windows_i686_msvc@0.36.1, windows_x86_64_gnu@0.28.0, windows_x86_64_gnu@0.36.1, windows_x86_64_msvc@0.28.0, windows_x86_64_msvc@0.36.1, write-json@0.1.2, xattr@0.2.3, xflags-macros@0.2.4, xflags@0.2.4, xshell-macros@0.2.2, xshell@0.2.2, xz2@0.1.6, yansi-term@0.1.2

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Suggests:
# lld and clang are needed for wasm compilation
# llvm is needed for llvm-dwp for -C split-debuginfo=packed
 cargo (>= 0.65.0~~), cargo (<< 0.66.0~~),
 llvm-14, lld-14, clang-14,
Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.65
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs,
 needed to run dynamically-linked Rust programs (-C prefer-dynamic).

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-1.65 (= ${binary:Version}),
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files for the standard Rust libraries,
 needed to compile Rust programs. It may also be installed on a system
 of another host architecture, for cross-compiling to this architecture.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,

## rustc 1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.18.04+9.0trisquel1

=== debian/changelog ===
rustc (1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.18.04+9.0trisquel1) etiona-backports; urgency=medium

  * Import as dependency of newer abrowser deb dependencies.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 25 Jan 2023 18:40:11 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: rustc
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Ximin Luo <infinity0@debian.org>,
@@ -140,4 +140,3 @@
  maintaining boundaries - both abstract and operational - that
  preserve large-system integrity, availability and concurrency.
  .
- It supports a mixture of imperative procedural, concurrent actor,

## rustc 1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.20.04+10.0trisquel1

=== debian/changelog ===
rustc (1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.20.04+10.0trisquel1) nabia-backports; urgency=medium

  * Import as dependency of newer abrowser deb dependencies.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 25 Jan 2023 18:40:36 +0000

rustc (1.65.0+dfsg0ubuntu1~llvm2-0ubuntu0.20.04) focal; urgency=medium

  * Update the vendored LLVM 15 to the latest bugfix release to fix ppc64el
    build.
  * Cherry-pick upstream patch to fix FTBFS on ppc64el and arm64

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 25 Jan 2023 18:02:05 +0100

rustc (1.65.0+dfsg0ubuntu1~llvm-0ubuntu0.20.04) focal; urgency=medium

  * Backport to focal (LP: #2000839)
  * Comment out vendored source tracking
  * Re-enable embedded LLVM:
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
    - Adjust debian/watch to include +llvm in upstream version.
    - Remove the rust-all dependency on llvm-14 due to vendoring
  * Revert debhelper compat 13 bump back to 12

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 20 Jan 2023 18:23:46 +0100

=== debian/control ===
--- 
+++ 
@@ -10,14 +10,14 @@
 # :native annotations are to support cross-compiling, see README.Debian
 Build-Depends:
  debhelper (>= 9),
- debhelper-compat (= 11),
+ debhelper-compat (= 12),
 # dh-cargo (>= 28ubuntu1~),
  dpkg-dev (>= 1.17.14),
  python3:native,
  cargo:native (>= 0.60.0)      <!pkg.rustc.dlstage0>,
  rustc:native (>= 1.64.0+dfsg) <!pkg.rustc.dlstage0>,
  rustc:native (<= 1.65.0++)    <!pkg.rustc.dlstage0>,
- cmake-mozilla,
+ cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
  pkg-config,
 # this is sometimes needed by rustc_llvm
